#ifndef HEAD_ACTOR
#define HEAD_ACTOR

#include "obj.h"
#include "script.h"
#include "stats.h"
#include "gen.h"
#include "lib.h"
#include <string>
#include <map>

class Actor {

	protected:

	std::string name;
	bool talkedTo;

	ScriptList scripts;
	FaceObj * mapObj;
	std::vector<MapObj *>::iterator objIndex;

	bool dead;

	public:

	struct Ai {
		int att;
		int def;
		int wild;
		int worth;
		std::string special;
	} ai;

	Actor ( std::string actorDir, int x, int y );
	virtual ~Actor () { ; }

	Stats stats;

	inline int retX1 () { return mapObj -> retX1 (); }
	inline int retY1 () { return mapObj -> retY1 (); }
	inline int retX2 () { return mapObj -> retX2 (); }
	inline int retY2 () { return mapObj -> retY2 (); }

	inline void setFace ( Compass face ) { mapObj -> setFace ( face ); }

	inline std::string retName () { return name; }
	inline bool retTalkedTo () { return talkedTo; }

	inline void setTalkedTo ( bool talkedTo ) { Actor::talkedTo = talkedTo; }

	virtual void run ();

	inline void draw () { mapObj -> draw (); }
	inline void draw ( int x, int y ) { mapObj -> draw ( x, y ); }

	void die ();
};

#endif