COMPILER = bcc32

FLAGS_GENERIC      = -w-8026 -DBCC -UMING 
FLAGS_EXECUTABLE   = $(FLAGS_GENERIC) -tW
FLAGS_OBJECT       = $(FLAGS_GENERIC) -c


notmucher.exe : notmucher.cpp keydefs.h gen.obj lib.obj gui.obj img.obj obj.obj map.obj stats.obj actor.obj event.obj script.obj cond.obj result.obj npc.obj pc.obj combat.obj
	$(COMPILER) $(FLAGS_EXECUTABLE) notmucher.cpp gen.obj lib.obj gui.obj img.obj obj.obj map.obj stats.obj actor.obj event.obj script.obj cond.obj result.obj npc.obj pc.obj combat.obj alleg.lib

gen.obj : gen.cpp gen.h lib.h gui.h
	$(COMPILER) $(FLAGS_OBJECT) gen.cpp

lib.obj : lib.cpp lib.h gen.h gui.h
	$(COMPILER) $(FLAGS_OBJECT) lib.cpp

gui.obj : gui.cpp gui.h gen.h lib.h
	$(COMPILER) $(FLAGS_OBJECT) gui.cpp

img.obj : img.cpp img.h gen.h lib.h
	$(COMPILER) $(FLAGS_OBJECT) img.cpp

obj.obj : obj.cpp obj.h gen.h lib.h img.h
	$(COMPILER) $(FLAGS_OBJECT) obj.cpp

map.obj : map.cpp map.h obj.h lib.h gen.h
	$(COMPILER) $(FLAGS_OBJECT) map.cpp

stats.obj : stats.cpp stats.h lib.h gen.h
	$(COMPILER) $(FLAGS_OBJECT) stats.cpp

actor.obj : actor.cpp actor.h script.h obj.h gen.h stats.h
	$(COMPILER) $(FLAGS_OBJECT) actor.cpp

event.obj : event.cpp event.h gen.h
	$(COMPILER) $(FLAGS_OBJECT) event.cpp

script.obj : script.cpp script.h event.h
	$(COMPILER) $(FLAGS_OBJECT) script.cpp

cond.obj : cond.cpp cond.h
	$(COMPILER) $(FLAGS_OBJECT) cond.cpp

result.obj : result.cpp result.h
	$(COMPILER) $(FLAGS_OBJECT) result.cpp

npc.obj : npc.cpp npc.h
	$(COMPILER) $(FLAGS_OBJECT) npc.cpp

pc.obj : pc.cpp pc.h
	$(COMPILER) $(FLAGS_OBJECT) pc.cpp

combat.obj : combat.cpp combat.h
	$(COMPILER) $(FLAGS_OBJECT) combat.cpp