#include "combat.h"
#include "actor.h"
#include "pc.h"
#include "gui.h"
#include "lib.h"
#include "gen.h"
#include <cstdlib>
using namespace std;

extern bool exitGame;

void combat ( Actor * npc ) {
	bool exitCombat = false;

	Bmp bkgd ( "data/combat.bmp" );
	pc -> setFace ( e );

	const int ATTVSATT = 3;
	const int ATTVSDEF = 2;
	const int ATTVSWILD = 3;
	const int DEFVSATT = 0;
	const int DEFVSDEF = 0;
	const int DEFVSWILD = 2;
	const int WILDVSATT = 5;
	const int WILDVSDEF = 0;
	const int WILDVSWILD = 5;
	const int DENOM = 25;

	const int MENUOFFY = 50;
	const int MENUHALFW = 75;
	const int MENUX1 = ( screenW / 2 ) - MENUHALFW;
	const int MENUY1 = MENUOFFY;
	const int MENUX2 = ( screenW / 2 ) + MENUHALFW;
	const int MENUY2 = screenH - MENUOFFY;
	Menu combatMenu ( "Thrust\nRiposte\nLunge\nRetreat", MENUX1, MENUY1, MENUX2, MENUY2 );

	int pcHP = pc -> stats [ "Health" ];
	int npcHP = npc -> stats [ "Health" ];

	while ( ! exitCombat ) {

		bkgd . tile ( 0, 0, screenW, screenH );

		TextBox pcStats ( pc -> retName ()
			+ "\n  Thrust: " + numToString ( pc -> stats [ "Thrust" ] )
			+ "\n  Riposte: " + numToString ( pc -> stats [ "Riposte" ] )
			+ "\n  Lunge: " + numToString ( pc -> stats [ "Lunge" ] )
			+ "\n  Health: " + numToString ( pcHP ) + "/" + numToString ( pc -> stats [ "Health" ] )
			, 0, pc -> retY2 () - pc -> retY1 () );

		pc -> draw ( 0, 0 );
		pcStats . draw ();

		const string grandmaName ( "George's Grandma" );
		int npcBoxX, npcBoxY;
		if ( npc -> retName () == grandmaName ) {
			npcBoxX = 0;
			npcBoxY = pcStats . retY2 () + 5;
		} else {
			npcBoxX = RIGHTALIGN;
			npcBoxY = ( npc -> retY2 () ) - ( npc -> retY1 () );
		}
		TextBox npcStats ( npc -> retName () 
			+ "\n  Thrust: " + numToString ( npc -> stats [ "Thrust" ] )
			+ "\n  Riposte: " + numToString ( npc -> stats [ "Riposte" ] )
			+ "\n  Lunge: " + numToString ( npc -> stats [ "Lunge" ] )
			+ "\n  Health: " + numToString ( npcHP ) + "/" + numToString ( npc -> stats [ "Health" ] )
			, npcBoxX, npcBoxY );

		int npcX = screenW - ( npc -> retX2 () - npc -> retX1 () );
		npc -> draw ( npcX, 0 );
		npcStats . draw ();

		enum Manoeuvre { att, def, wild, flee };

		int npcMove = rand () % 30;
		if ( npcMove < npc -> ai . att )
			npcMove = att;
		else if ( npcMove < ( npc -> ai . def + npc -> ai . att ) )
			npcMove = def;
		else
			npcMove = wild;

		int pcMult, npcMult;

		string pcStat;
		string npcStat;

		switch ( combatMenu . run () ) {
			case att :
				switch ( npcMove ) {
					case att:
						pcMult = ATTVSATT;
						npcMult = ATTVSATT;
						pcStat = "Thrust";
						npcStat = "Thrust";
						MsgBox ( pc -> retName () + " and " + npc -> retName () + " exchange blows.", CENTER, CENTER );
					break;
					case def:
						pcMult = ATTVSDEF; npcMult = DEFVSATT;
						pcStat = "Thrust"; npcStat = "Riposte";
						MsgBox ( npc -> retName () + " knocks " + pc -> retName () + "'s blow slightly\noff-course, though it still lands.", CENTER, CENTER );
					break;
					case wild:
						pcMult = ATTVSWILD; npcMult = WILDVSATT;
						pcStat = "Thrust"; npcStat = "Lunge";
						MsgBox ( pc -> retName () + " connects, but " + npc -> retName () + " absolutely\nmauls her in return.", CENTER, CENTER );
				}
			break;
			case def:
				switch ( npcMove ) {
					case att:
						pcMult = DEFVSATT; npcMult = ATTVSDEF;
						pcStat = "Riposte"; npcStat = "Thrust";
						MsgBox ( pc -> retName () + " blocks some, but not all, of the force\nbehind " + npc -> retName () + "'s blow.", CENTER, CENTER );
					break;
					case def:
						pcMult = DEFVSDEF; npcMult = DEFVSDEF;
						pcStat = "Riposte"; npcStat = "Riposte";
						MsgBox ( pc -> retName () + " and " + npc -> retName () + " cautiously square off,\nneither willing to make the first move.", CENTER, CENTER );
					break;
					case wild:
						pcMult = DEFVSWILD; npcMult = WILDVSDEF;
						pcStat = "Riposte"; npcStat = "Lunge";
						MsgBox ( npc -> retName () + " screams forward, but " + pc -> retName () + " slips underneath the\nblow, landing a swift shot from below.", CENTER, CENTER );
				}
			break;
			case wild:
				switch ( npcMove ) {
					case att:
						pcMult = WILDVSATT; npcMult = ATTVSWILD;
						pcStat = "Lunge"; npcStat = "Thrust";
						MsgBox ( npc -> retName () + " strikes, but " + pc -> retName () + " deals a massive retaliatory blow.", CENTER, CENTER );
					break;
					case def:
						pcMult = WILDVSDEF; npcMult = DEFVSWILD;
						pcStat = "Lunge"; npcStat = "Riposte";
						MsgBox ( pc -> retName () + " lunges forward, but " + npc -> retName () + " deftly\nturns it aside and lands one of its own.", CENTER, CENTER );
					break;
					case wild:
						pcMult = WILDVSWILD; npcMult = WILDVSWILD;
						pcStat = "Lunge"; npcStat = "Lunge";
						MsgBox ( pc -> retName () + " and " + npc -> retName () + " trade wildly powerful blows.", CENTER, CENTER );
				}
			break;
			case flee:
				if ( ( rand () % 2 ) == 0 ) {
					MsgBox ( pc -> retName () + " manages to escape from the battle.", CENTER, CENTER );
					exitCombat = true;
					break;
				} else {
					if ( npcMove == att ) {
						pcMult = DEFVSATT; npcMult = ATTVSDEF;
						pcStat = "Riposte"; npcStat = "Thrust";
						MsgBox ( pc -> retName () + " fails to escape the battle, and " + npc -> retName () + " gives her a good\nslap upside the head for the attempt.", CENTER, CENTER );
					} else if ( npcMove == def ) {
						pcMult = WILDVSDEF; npcMult = DEFVSWILD;
						pcStat = "Lunge"; npcStat = "Riposte";
						MsgBox ( pc -> retName () + " attempts to flee by barreling straight towards " + npc -> retName () + "\nwho promptly trips her and gives her a swift kick for good measure.", CENTER, CENTER );
					} else {
						pcMult = ATTVSWILD; npcMult = WILDVSATT;
						pcStat = "Thrust"; npcStat = "Lunge";
						MsgBox ( pc -> retName () + " fails to escape, at which " + npc -> retName () + " deals her a vicious blow from\nbehind, though " + pc -> retName () + " does manage to get in a glancing one of her own.", CENTER, CENTER );
					}
				}
		}

		static int deathCntr = 0;

		if ( ! exitCombat ) {
			npcHP -= ( pc -> stats [ pcStat ] * pcMult ) / DENOM;
			pcHP -= ( npc -> stats [ npcStat ] * npcMult ) / DENOM;

			npc -> stats [ npcStat ] += 1;
			pc -> stats [ pcStat ] += 1;

			if ( ( rand () % 3 ) == 0 )
				pc -> stats  [ "Health" ] += 1;

			if ( npcHP < 1 && pcHP < 1 ) {
				MsgBox ( "Ooh, so very close... but how to choose a winner?\nEenie, meenie, minie, moe... aah, what the hell, you win.", CENTER, CENTER );
			}

			if ( npcHP < 1 ) {
				int expBonus = npc -> ai . worth;

				pc -> stats [ "Thrust" ] += expBonus;
				pc -> stats [ "Riposte" ] += expBonus;
				pc -> stats [ "Lunge" ] += expBonus;
				pc -> stats [ "Health" ] += expBonus;

				MsgBox ( "You've defeated " + npc -> retName (), CENTER, CENTER );
				MsgBox ( "You gain a +" + numToString ( expBonus ) + " bonus to all stats.\n  Thrust: " + numToString ( pc -> stats [ "Thrust" ] ) + "\n  Riposte: " + numToString ( pc -> stats [ "Riposte" ] ) + "\n  Lunge: " + numToString ( pc -> stats [ "Lunge" ] ) + "\n  Health: " + numToString ( pc -> stats [ "Health" ] ), CENTER, CENTER );

				if ( npc -> retName () == grandmaName ) {
					Lib_Clr clr = createClr ( 200, 200, 200 );
					clearScreenToClr ( clr );
					MsgBox ( "You've defeated " + npc -> retName (), CENTER, CENTER );
					clearScreenToClr ( clr );
					MsgBox ( "You gain a +" + numToString ( expBonus ) + " bonus to all stats.\n  Thrust: " + numToString ( pc -> stats [ "Thrust" ] ) + "\n  Riposte: " + numToString ( pc -> stats [ "Riposte" ] ) + "\n  Lunge: " + numToString ( pc -> stats [ "Lunge" ] ) + "\n  Health: " + numToString ( pc -> stats [ "Health" ] ), CENTER, CENTER );
					clearScreenToClr ( clr );
					MsgBox ( "And more importantly, you win!", CENTER, CENTER );
					clearScreenToClr ( clr );
					MsgBox ( "Congratulations!  Your stamina is truly impressive.", CENTER, CENTER );
					clearScreenToClr ( clr );
					MsgBox ( "Sorry this game was such a piece of crap.", CENTER, CENTER );
					clearScreenToClr ( clr );
					MsgBox ( "Bye.", CENTER, CENTER );
					exitGame = true;
				}


				npc -> die ();
				pc -> setSkip ();

				exitCombat = true;
			} else if ( pcHP < 1 ) {
				deathCntr ++;
				MsgBox ( "Sorry; you lose.  The poor child dies a horroriferous death at the hands of " + npc -> retName () + ".", CENTER, CENTER );
				MsgBox ( "But, since you're a nice guy/gal, and since I\nnever got around to adding a save\nfeature to this game, I guess I might\nas well let you keep on playing.", CENTER, CENTER );
				if ( deathCntr > 1 )
					MsgBox ( "Just for the record, though, you've died " + numToString ( deathCntr ) + " times.", CENTER, CENTER );
				exitCombat = true;
			}
		}
	}
}