#ifndef HEAD_COND
#define HEAD_COND

#include <string>
#include <vector>

class Actor;

class Cond {

	protected:

	Actor * self;

	public:

	Cond ( Actor * self ) { Cond::self = self; }
	virtual ~Cond () { ; }

	virtual bool eval () = 0;
};

class Flag : public Cond {

	private:

	int flagId;

	public:

	Flag ( Actor * self, std::string flagName );
	~Flag () { ; }

	bool eval ();
};

class NotFlag : public Cond {

	private:

	int flagId;

	public:

	NotFlag ( Actor * self, std::string flagName );
	~NotFlag () { ; }

	bool eval ();
};

class TalkedTo : public Cond {

	public:

	TalkedTo ( Actor * self );
	~TalkedTo () { ; }

	bool eval ();
};

class StatLess : public Cond {

	private:

	std::string statName;
	int statVal;

	public:

	StatLess ( Actor * self, std::string args );
	~StatLess () { ; }

	bool eval ();
};

class StatMore : public Cond {

	private:

	std::string statName;
	int statVal;

	public:

	StatMore ( Actor * self, std::string args );
	~StatMore () { ; }

	bool eval ();
};

class CondList {

	private:

	typedef std::vector<Cond *> Conds;
	Conds conds;

	std::string stripArg ( std::string & line );

	public:

	CondList ( Actor * self, std::string line );
	~CondList ();

	bool eval ();
};

#endif
