#include "event.h"
#include "lib.h"
#include "gen.h"
#include <map>
#include <vector>
#include <string>
using namespace std;

EventList::EventList ( string eventFile ) {
	const char DIV = ':';
	const string SET ( "set" );
	const string CLEAR ( "clear" );

	FileIn eventIn ( eventFile );

	string line;
	int cntr = 0;
	while ( ! eventIn . eof () ) {
		line = eventIn . getLine ();
		if ( line . find ( DIV ) != string::npos ) {
			string lside = line . substr ( 0, line . find ( DIV ) );
			string rSide = line . substr ( line . find ( DIV ) + 1, string::npos );

			namesAndIds [ lside ] = cntr++;

			if ( rSide == SET )
				events . push_back ( true );
			else if ( rSide == CLEAR )
				events . push_back ( false );
			else
				fatErrMsg ( "Event flag list from " + eventFile + " improperly formatted at line " + line + "." );
		} else {
			namesAndIds [ line ] = cntr++;
			events . push_back ( false );
		}
	}
}

EventList::~EventList () {
	;
}

int EventList::retIndex ( string flagName ) {
	if ( namesAndIds . find ( flagName ) == namesAndIds . end () )
		fatErrMsg ( "Attempt to access non-existent event flag " + flagName + "." );

	return ( * namesAndIds . find ( flagName ) ) . second;

}