#ifndef HEAD_EVENT
#define HEAD_EVENT

#include "gen.h"
#include "lib.h"
#include <map>
#include <vector>
#include <string>

class EventList {

	private:

	struct RealBool {
		bool val;

		operator const bool & () const {
			return val;
		}
		RealBool ( bool val ) {
			RealBool::val = val;
		}
	};
	std::vector <RealBool> events;
	std::map <std::string, int> namesAndIds;

	public:

	bool & operator[] ( int index ) {
		return ( events [ index ] . val );
	}

	EventList ( std::string eventFile );
	~EventList ();

	int retIndex ( std::string name );
	inline bool retEvent ( int index ) { return events [ index ]; }

	inline void setEvent ( int index ) { events [ index ] = true; }
	inline void clearEvent ( int index ) { events [ index ] = false; }

	void saveToFile ( FileIn file );
	void loadFromFile ( FileIn file );
};

extern EventList eventList;

#endif