#include "lib.h"
#include "gen.h"

#include <string>
#include <strstream>
#include <fstream>
#include <utility>
using namespace std;

int exponentiation ( unsigned int base, unsigned int power ) {
	if ( power == 0 ) {
		return 1;
	}
	return base * exponentiation ( base, --power );
}

string numToString ( int num ) {
	const int RADIX = 10;
	char charBuf [ 20 ];

	#ifdef BCC
		itoa ( num, charBuf, RADIX );
		#define GOODNUMSTR
	#endif
	#ifdef MING
		itoa ( num, charBuf, RADIX );
		#define GOODNUMSTR
	#endif

	#ifndef GOODNUMSTR
		blaaargh!
	#endif
	return string ( charBuf );
}

pair <string, string> stripArgs ( string & line, char leftArg, char rightArg ) {
	Strind leftArgInd = line . find ( leftArg );
	Strind rightArgInd = line . find ( rightArg );

	if ( leftArgInd == string::npos || rightArgInd == string::npos )
		fatErrMsg ( "Argument expected in line " + line + "." );

	pair <string, string> retPair;
	retPair . first = line . substr ( 0, leftArgInd );

	if ( rightArgInd - leftArgInd == 1 )
		retPair . second . clear ();
	else
		retPair . second = line . substr ( leftArgInd + 1, rightArgInd - leftArgInd - 1 );

	line = line . substr ( rightArgInd + 1, string::npos );
	return retPair;
}


// FileIn

FileIn::FileIn ( string fileName )
: streamIn ( fileName . c_str () ) {
	if ( ! streamIn . is_open () )
		fatErrMsg ( "Error opening file from \"" + fileName + "\"." );

	eofFlag = false;
	getLine ();
	if ( eofFlag )
		fatErrMsg ( "Attempt to open empty file from \"" + fileName + "\"." );
}

FileIn::~FileIn () {
	streamIn . close ();
}

void FileIn::reopen ( string fileName ) {
	streamIn . close ();
	streamIn . open ( fileName . c_str () );

	if ( ! streamIn . is_open () )
		fatErrMsg ( "Error re-opening file from \"" + fileName + "\"." );

	eofFlag = false;
	getLine ();
	if ( eofFlag )
		fatErrMsg ( "Attempt to re-open empty file from \"" + fileName + "\"." );
}

string FileIn::getLine () {
/*
	if ( eofFlag )
		fatErrMsg ( "Attempt to read past end of file." );
*/

	string returnLine = lineBuff;
	bool newBuff = false;

	while ( ! streamIn . eof () ) {
		getline ( streamIn, lineBuff );

		if ( ! ( lineBuff . empty () ) && lineBuff [ 0 ] != COMMENT ) {
			newBuff = true;
			break;
		}
	}

	if ( ! newBuff )
		eofFlag = true;

	return returnLine;
}