/* This file defines a number of commonly used functions which don't fit anywhere else */

#ifndef HEAD_GEN
#define HEAD_GEN

#include <string>
#include <fstream>
#include <vector>
#include <cstddef>
#include <utility>

#define DIRSLASH "\\"

const char NEWLINE = '\n';

enum Compass { n, ne, e, se, s, sw, w, nw, nil };

typedef std::string::size_type Strind;

inline int biggest ( int num1, int num2 ) { if ( num1 > num2 ) return num1; else return num2; }
int exponentiation ( unsigned int base, unsigned int power );

std::string numToString ( int number );

std::pair <std::string, std::string> stripArgs ( std::string & line, char leftArg, char rightArg );

template <class dataType>
void initialize2dVector ( std::vector <std::vector <dataType> > & vector2d, int dimensions ) {
	std::vector <dataType> vector1d ( dimensions );

	for ( int i = 0; i < dimensions; i++ ) {
		vector2d . push_back ( vector1d );
	}
}

template <class dataType>
void initialize2dVector ( std::vector <std::vector <dataType> > & vector2d, int xDimension, int yDimension ) {
	std::vector <dataType> vector1d ( yDimension );

	for ( int i = 0; i < xDimension; i++ ) {
		vector2d . push_back ( vector1d );
	}
}

const char COMMENT = '#';
class FileIn {

	private:

	std::string lineBuff;
	std::ifstream streamIn;

	bool fileOpen;
	bool eofFlag;

	public:

	FileIn ( std::string fileName );
	~FileIn ();

	void reopen ( std::string fileName );

	inline bool eof () { return eofFlag; }
	std::string getLine ();
};

#endif