#include "gui.h"
#include "lib.h"
#include "gen.h"
#include <string>
using namespace std;

#define GUIBMPDIR DATADIR "/gui/"
#define BKGDBMPFILE GUIBMPDIR "bkgd.bmp"
#define NBORDBMPFILE GUIBMPDIR "bordern.bmp"
#define NEBORDBMPFILE GUIBMPDIR "borderne.bmp"
#define EBORDBMPFILE GUIBMPDIR "bordere.bmp"
#define SEBORDBMPFILE GUIBMPDIR "borderse.bmp"
#define SBORDBMPFILE GUIBMPDIR "borders.bmp"
#define SWBORDBMPFILE GUIBMPDIR "bordersw.bmp"
#define WBORDBMPFILE GUIBMPDIR "borderw.bmp"
#define NWBORDBMPFILE GUIBMPDIR "bordernw.bmp"

Bmp * bkgdBmp = NULL;
Bmp * nBordBmp = NULL;
Bmp * neBordBmp = NULL;
Bmp * eBordBmp = NULL;
Bmp * seBordBmp = NULL;
Bmp * sBordBmp = NULL;
Bmp * swBordBmp = NULL;
Bmp * wBordBmp = NULL;
Bmp * nwBordBmp = NULL;

const int TEXTOFF = 5;
int textOffX1 = 0;
int textOffY1 = 0;
int textOffX2 = 0;
int textOffY2 = 0;

Lib_Clr curTextClr;
Lib_Clr curSelTextClr;

bool guiLoaded = false;

void initGui () {
	bkgdBmp = new Bmp ( BKGDBMPFILE );
	nBordBmp = new Bmp ( NBORDBMPFILE );
	neBordBmp = new Bmp ( NEBORDBMPFILE );
	eBordBmp = new Bmp ( EBORDBMPFILE );
	seBordBmp = new Bmp ( SEBORDBMPFILE );
	sBordBmp = new Bmp ( SBORDBMPFILE );
	swBordBmp = new Bmp ( SWBORDBMPFILE );
	wBordBmp = new Bmp ( WBORDBMPFILE );
	nwBordBmp = new Bmp ( NWBORDBMPFILE );

	textOffX1 = wBordBmp -> retW () + TEXTOFF;
	textOffY1 = nBordBmp -> retH () + TEXTOFF;
	textOffX2 = eBordBmp -> retW () + TEXTOFF;
	textOffY2 = sBordBmp -> retH () + TEXTOFF;

	curTextClr = createClr ( 255, 255, 255 );
	curSelTextClr = createClr ( 255, 255, 0 );

	guiLoaded = true;
}



// GuiBox definitions

void GuiBox::loadBmp () {
	const int BMPX1 = 0;
	const int BMPY1 = 0;
	const int BMPX2 = BMPX1 + x2 - x1;
	const int BMPY2 = BMPY1 + y2 - y1;

	bkgdBmp -> tileToBmp ( boxBmp, BMPX1, BMPY1, BMPX2, BMPY2 );

	const int NWBORDX1 = BMPX1;
	const int NWBORDY1 = BMPY1;
	const int NWBORDX2 = NWBORDX1 + nwBordBmp -> retW () - 1;
	const int NWBORDY2 = NWBORDY1 + nwBordBmp -> retH () - 1;
	nwBordBmp -> drawToBmp ( boxBmp, NWBORDX1, NWBORDY1 );

	const int NEBORDX1 = BMPX2 - neBordBmp -> retW ();
	const int NEBORDY1 = BMPY1;
	const int NEBORDX2 = NEBORDX1 + neBordBmp -> retW () - 1;
	const int NEBORDY2 = NEBORDY1 + neBordBmp -> retH () - 1;
	neBordBmp -> drawToBmp ( boxBmp, NEBORDX1, NEBORDY1 );

	const int SWBORDX1 = BMPX1;
	const int SWBORDY1 = BMPY2 - swBordBmp -> retH ();
	const int SWBORDX2 = SWBORDX1 + swBordBmp -> retW () - 1;
	const int SWBORDY2 = SWBORDY1 + swBordBmp -> retH () - 1;
	swBordBmp -> drawToBmp ( boxBmp, SWBORDX1, SWBORDY1 );

	const int SEBORDX1 = BMPX2 - seBordBmp -> retW ();
	const int SEBORDY1 = BMPY2 - seBordBmp -> retH ();
	const int SEBORDX2 = SEBORDX1 + seBordBmp -> retW () - 1;
	const int SEBORDY2 = SEBORDY1 + seBordBmp -> retH () - 1;
	seBordBmp -> drawToBmp ( boxBmp, SEBORDX1, SEBORDY1 );

	const int NBORDX1 = NWBORDX2 + 1;
	const int NBORDY1 = BMPY1;
	const int NBORDX2 = NEBORDX1 - 1;
	const int NBORDY2 = nBordBmp -> retH () - 1;
	nBordBmp -> tileToBmp ( boxBmp, NBORDX1, NBORDY1, NBORDX2, NBORDY2 );

	const int WBORDX1 = BMPX1;
	const int WBORDY1 = NWBORDY2 + 1;
	const int WBORDX2 = wBordBmp -> retW () - 1;
	const int WBORDY2 = SWBORDY1 - 1;
	wBordBmp -> tileToBmp ( boxBmp, WBORDX1, WBORDY1, WBORDX2, WBORDY2 );

	const int SBORDX1 = SWBORDX2 + 1;
	const int SBORDY1 = BMPY2 - sBordBmp -> retH ();
	const int SBORDX2 = SEBORDX1 - 1;
	const int SBORDY2 = BMPY2 - 1;
	sBordBmp -> tileToBmp ( boxBmp, SBORDX1, SBORDY1, SBORDX2, SBORDY2 );

	const int EBORDX1 = BMPX2 - eBordBmp -> retW ();
	const int EBORDY1 = NEBORDY2 + 1;
	const int EBORDX2 = BMPX2 - 1;
	const int EBORDY2 = SEBORDY1 - 1;
	eBordBmp -> tileToBmp ( boxBmp, EBORDX1, EBORDY1, EBORDX2, EBORDY2 );
}

GuiBox::GuiBox ( int x1, int y1, int x2, int y2 )
: boxBmp ( x2 - x1, y2 - y1 ) {

	if ( ! guiLoaded )
		fatErrMsg ( "Attempt to create GuiBox before gui is loaded." );

	GuiBox::x1 = x1;
	GuiBox::y1 = y1;
	GuiBox::x2 = x2;
	GuiBox::y2 = y2;

	loadBmp ();
}



// TextBox definitions

TextBox::TextBox ( string text, int x, int y, Font * font, Lib_Clr textClr ) {

	if ( ! guiLoaded )
		fatErrMsg ( "Attempt to load TextBox containing text \"" + text + "\" before gui is loaded." );

	while ( text . find ( NEWLINE ) != string::npos ) {
		string line = text . substr ( 0, text . find ( NEWLINE ) );
		TextBox::text . push_back ( line );
		text = text . substr ( text . find ( NEWLINE ) + 1, string::npos );
	}
	TextBox::text . push_back ( text );

	TextBox::font = font;
	TextBox::textClr = textClr;

	int biggestLineW = 0;
	for ( unsigned int i = 0; i < TextBox::text . size (); i++ )
		if ( font -> retW ( TextBox::text [ i ] ) > biggestLineW )
			biggestLineW = font -> retW ( TextBox::text [ i ] );

	int x2, y2;
	if ( x == RIGHTALIGN ) {
		x2 = screenW;
		x = x2 - ( textOffX1 + textOffX2 + biggestLineW );
	} else if ( x == CENTER ) {
		x = ( screenW - ( textOffX1 + textOffX2 + biggestLineW ) ) / 2;
		x2 = x + textOffX1 + textOffX2 + biggestLineW;
	} else {
		x2 = x + textOffX1 + textOffX2 + biggestLineW;
	}
	if ( y == BOTTOMALIGN ) {
		y2 = screenH;
		y = y2 - TextBox::text . size () * ( font -> retH () ) + textOffY1 + textOffY2;
	} else if ( y == CENTER ) {
		y = ( screenH - ( TextBox::text . size () * ( font -> retH () ) + textOffY1 + textOffY1 ) ) / 2;
		y2 = y + TextBox::text . size () * ( font -> retH () ) + textOffY1 + textOffY2;
	} else {
		y2 = y + TextBox::text . size () * ( font -> retH () ) + textOffY1 + textOffY2;
	}
		
	box = new GuiBox ( x, y, x2, y2 );
}

void TextBox::draw () const {
	box -> draw ();

	for ( unsigned int i = 0; i < text . size (); i++ ) {
		const int TEXTX = retX1 () + textOffX1;
		const int TEXTY = retY1 () + textOffY1 + ( i * font -> retH () );
		font -> draw ( text [ i ], TEXTX, TEXTY, textClr );
	}
}



// MsgBox definitions

MsgBox::MsgBox ( string text, int x, int y, Font * font, Lib_Clr textClr )
	: TextBox ( text, x, y, font, textClr ) {

	draw ();
	drawScreen ();
	keyboard -> waitForTap ( KEY_SPACE );
}



// Btn definitions

Btn::Btn ( string text, int x, int y, Font * font, Lib_Clr textClr, Lib_Clr selTextClr )
	: TextBox ( text, x, y, font, textClr ) {

	Btn::selTextClr = selTextClr;
	sel = false;
}

void Btn::draw () const {
	box -> draw ();
	for ( unsigned int i = 0; i < text . size (); i++ ) {
		const int TEXTX = retX1 () + textOffX1;
		const int TEXTY = retY1 () + textOffY1 + ( i * font -> retH () );
		font -> draw ( text [ i ], TEXTX, TEXTY, sel ? selTextClr : textClr );
	}
}



// EmptyBox

EmptyBox::EmptyBox ( int x1, int y1, int x2, int y2 ) {
	box = new GuiBox ( x1, y1, x2, y2 );
}

void EmptyBox::draw () {
	box -> draw ();
}



// Menu

Menu::Menu ( string text, int x1, int y1, int x2, int y2, Font * font, Lib_Clr textClr, Lib_Clr selTextClr )
: EmptyBox ( x1, y1, x2, y2 ), curSel ( 0 ) {

	vector <string> btnsText;

	while ( true ) {
		if ( text . find ( '\n' ) != string::npos ) {
			btnsText . push_back ( text . substr ( 0, text . find ( '\n' ) ) );
			text = text . substr ( text . find ( '\n' ) + 1, string::npos );
		} else {
			btnsText . push_back ( text );
			break;
		}
	}

	const int INTERSPACE = 2; // the number of pixels between boxes
	const int NUMBOXES = btnsText . size ();

	const int BTNX = retX1 () + textOffX1;
	const int BTNY = retY1 () + textOffY1;
	Btn * temp = new Btn ( btnsText [ 0 ], BTNX, BTNY, font, textClr, selTextClr );
	btns . push_back ( temp );

	for ( int i = 1; i < NUMBOXES; i++ ) {
		const int BTNX = retX1 () + textOffX1;
		const int BTNY = btns [ i - 1 ] -> retY2 () + INTERSPACE;

		Btn * temp = new Btn ( btnsText [ i ], BTNX, BTNY, font, textClr, selTextClr );
		btns . push_back ( temp );
	}
}

Menu::~Menu () {
	for ( vector <Btn *>::iterator it = btns . begin (); it != btns . end (); it ++ )
		delete (*it);
}

void Menu::draw () {
	EmptyBox::draw ();
	for ( Btns::iterator it = btns . begin (); it != btns . end (); it ++ )
		(*it) -> draw ();
}

int Menu::run () {
	draw ();
	drawScreen ();

	while ( ! keyboard -> tap ( KEY_SPACE ) ) {
		box -> draw ();

		for ( int i = 0; i < ( int ) btns . size (); i++ ) {
			if ( i == curSel )
				btns [ i ] -> setSel ( true );
			else
				btns [ i ] -> setSel ( false );
			btns [ i ] -> draw ();
		}

		drawScreen ();

		if ( keyboard -> tap ( KEY_DOWN ) && curSel < ( int ) btns . size () - 1 )
			curSel++;
		if ( keyboard -> tap ( KEY_UP ) && curSel > 0 )
			curSel--;
	}

	return curSel;
}





// VoxBox definitions

VoxBox::VoxBox ( string text, Font * font, Lib_Clr textClr ) {
	if ( ! guiLoaded )
		fatErrMsg ( "Attempt to create VoxBox containing text \"" + text + "\" before gui is loaded." );

	const int VOXOFF = 10;
	const int VOXH = ( int ) ( screenH / 3 ) - VOXOFF;
	const int VOXX1 = 0 + VOXOFF;
	const int VOXY2 = screenH - VOXOFF;
	const int VOXX2 = screenW - VOXOFF;
	const int VOXY1 = VOXY2 - VOXH;

	VoxBox::font = font;
	VoxBox::textClr = textClr;

	text = font -> wrapToWidth ( text, VOXX2 - VOXX1 + 1 - textOffX1 - textOffX2 );

	while ( text . find ( NEWLINE ) != string::npos ) {
		string line = text . substr ( 0, text . find ( NEWLINE ) );
		VoxBox::text . push_back ( line );
		text = text . substr ( text . find ( NEWLINE ) + 1, string::npos );
	}
	VoxBox::text . push_back ( text );

	box = new GuiBox ( VOXX1, VOXY1, VOXX2, VOXY2 );
}

int VoxBox::run () {
	box -> draw ();

	for ( unsigned int i = 0; i < text . size (); i++ ) {
		const int TEXTX = retX1 () + textOffX1;
		const int TEXTY = retY1 () + textOffY1 + ( i * font -> retH () );
		font -> draw ( text [ i ], TEXTX, TEXTY, textClr );
	}

	drawScreen ();
	keyboard -> waitForTap ( KEY_SPACE );

	return 0;
}



// ChoiceBox

ChoiceBox::ChoiceBox ( string text, Font * font, Lib_Clr textClr, Lib_Clr selTextClr )
: VoxBox ( text, font, textClr ) {

	curSel = 0;

	const int INTERSPACE = 2; // the number of pixels between boxes
	const int NUMBOXES = VoxBox::text . size ();

	const int BTNX = retX1 () + textOffX1;
	const int BTNY = retY1 () + textOffY1;
	Btn * temp = new Btn ( VoxBox::text [ 0 ], BTNX, BTNY, font, textClr, selTextClr );
	btns . push_back ( temp );

	for ( int i = 1; i < NUMBOXES; i++ ) {
		const int BTNX = retX1 () + textOffX1;
		const int BTNY = btns [ i - 1 ] -> retY2 () + INTERSPACE;

		Btn * temp = new Btn ( VoxBox::text [ i ], BTNX, BTNY, font, textClr, selTextClr );
		btns . push_back ( temp );
	}
}

int ChoiceBox::run () {
	while ( ! keyboard -> tap ( KEY_SPACE ) ) {
		box -> draw ();

		for ( int i = 0; i < ( int ) btns . size (); i++ ) {
			if ( i == curSel )
				btns [ i ] -> setSel ( true );
			else
				btns [ i ] -> setSel ( false );
			btns [ i ] -> draw ();
		}

		drawScreen ();

		if ( keyboard -> tap ( KEY_DOWN ) && curSel < ( int ) btns . size () - 1 )
			curSel++;
		if ( keyboard -> tap ( KEY_UP ) && curSel > 0 )
			curSel--;
	}

	return curSel;
}