COMPILER = G++

FLAGS_GENERIC		= -Wno-deprecated -DMING -UBCC -D__GTHREAD_HIDE_WIN32API
FLAGS_EXECUTABLE	= $(FLAGS_GENERIC) -onotmucher -lalleg -mwindows
FLAGS_OBJECT		= $(FLAGS_GENERIC) -c


notmucher.exe : notmucher.cpp keydefs.h gen.o lib.o gui.o img.o obj.o map.o actor.o event.o script.o pc.o npc.o combat.o stats.o cond.o result.o
	$(COMPILER) notmucher.cpp gen.o lib.o gui.o img.o obj.o map.o actor.o event.o script.o pc.o npc.o combat.o stats.o cond.o result.o $(FLAGS_EXECUTABLE)

gen.o : gen.cpp gen.h lib.h gui.h
	$(COMPILER) gen.cpp $(FLAGS_OBJECT)

lib.o : lib.cpp lib.h gen.h gui.h
	$(COMPILER) lib.cpp $(FLAGS_OBJECT)

gui.o : gui.cpp gui.h gen.h lib.h
	$(COMPILER) gui.cpp $(FLAGS_OBJECT)

img.o : img.cpp img.h gen.h lib.h
	$(COMPILER) img.cpp $(FLAGS_OBJECT)

obj.o : obj.cpp obj.h gen.h lib.h img.h
	$(COMPILER) obj.cpp $(FLAGS_OBJECT)

map.o : map.cpp map.h obj.h lib.h gen.h
	$(COMPILER) map.cpp $(FLAGS_OBJECT)

actor.o : actor.cpp actor.h obj.h gen.h
	$(COMPILER) actor.cpp $(FLAGS_OBJECT)

event.o : event.cpp event.h gen.h
	$(COMPILER) event.cpp $(FLAGS_OBJECT)

script.o : script.cpp script.h event.h
	$(COMPILER) script.cpp $(FLAGS_OBJECT)

pc.o : pc.cpp pc.h
	$(COMPILER) pc.cpp $(FLAGS_OBJECT)

npc.o : npc.cpp npc.h
	$(COMPILER) npc.cpp $(FLAGS_OBJECT)

combat.o : combat.cpp combat.h
	$(COMPILER) combat.cpp $(FLAGS_OBJECT)

stats.o : stats.cpp stats.h
	$(COMPILER) stats.cpp $(FLAGS_OBJECT)

cond.o : cond.cpp cond.h
	$(COMPILER) cond.cpp $(FLAGS_OBJECT)

result.o : result.cpp result.h
	$(COMPILER) result.cpp $(FLAGS_OBJECT)