#ifdef BCC
	#ifdef MING
		blaaargh!
	#endif
#endif
#ifdef BCC
	#include "bccalleg.h"
#endif
#ifdef MING
	#include <allegro.h>
#endif


#include "combat.h"
#include "pc.h"
#include "npc.h"
#include "script.h"
#include "event.h"
#include "actor.h"
#include "map.h"
#include "obj.h"
#include "img.h"
#include "gui.h"
#include "lib.h"
#include "gen.h"
#include <string>
#include <ctime>
#include <cstdlib>
using namespace std;

Sprite * emptySprite;

bool exitGame = false;

void loadScene ( string gameMapDir ) {
	imgList -> load ( gameMapDir + "objs.txt" );
	gameMap -> load ( gameMapDir + "map.txt" );
	loadPc ( gameMapDir + "actors.txt" );
	loadNpcs ( gameMapDir + "actors.txt" );
}

void destroyScene () {
	imgList -> destroy ();
	gameMap -> destroy ();
	destroyPc ();
	destroyNpcs ();
}

EventList eventList ( "data/flags.txt" );

string scene ( "data/maps/01/" );
bool firstScene = true;

int moveCount = 0;
bool firstRound = true;
bool firstTime = true;

int main ( int argc, char * argv [] ) {
	srand ( time ( NULL ) );

	initLib ();
	initGui ();

	imgList = new ImgList ();
	gameMap = new Map ();

	emptySprite = new Sprite ( "data/empty.bmp" );


	#define BATTLESPEED 150
	#define RANDENEMIES 6
	#define ENEMDIR "data/actors/animals/"
	int movesTilBattle = BATTLESPEED + rand () % BATTLESPEED;
	while ( ! exitGame ) {
		if ( moveCount > movesTilBattle ) {
			string name;
			switch ( rand () % RANDENEMIES ) {
				case 0 :
					name = ENEMDIR "longchick/";
				break;
				case 1 :
					name = ENEMDIR "bigchick/";
				break;
				case 2:
					name = ENEMDIR "wooly/";
				break;
				case 3:
					name = ENEMDIR "firepig/";
				break;
				case 4:
					name = ENEMDIR "madcow/";
				break;
				case 5:
					name = ENEMDIR "alma/";
				break;
			}

			Actor * combatant = new Actor ( name, 0, 0 );
			MsgBox ( "You are attacked by " + combatant -> retName () + ".", CENTER, CENTER );
			combat ( combatant );
			delete combatant;
			movesTilBattle = BATTLESPEED + rand () % BATTLESPEED;
			moveCount = 0;
		}

		if ( keyboard -> press ( KEY_ESC ) ) {
			ChoiceBox exitBox ( "Remain in the Game.\nQuit the Game." );
			switch ( exitBox . run () ) {
				case 0 : break;
				case 1 : exit ( EXIT_SUCCESS );
			}
		}

		if ( ! scene . empty () )
			if ( firstScene ) {
				loadScene ( scene );
				firstScene = false;
				scene . clear ();
			} else {
				destroyScene ();
				loadScene ( scene );
				scene . clear ();
				moveCount = 0;
			}

		// just some test stuff
		if ( keyboard -> press ( KEY_1 ) )
			pxlsPerMove = 1;
		else if ( keyboard -> press ( KEY_2 ) )
			pxlsPerMove = 2;
		else if ( keyboard -> press ( KEY_3 ) )
			pxlsPerMove = 3;
		else if ( keyboard -> press ( KEY_4 ) )
			pxlsPerMove = 4;
		else if ( keyboard -> press ( KEY_5 ) )
			pxlsPerMove = 5;
		else if ( keyboard -> press ( KEY_6 ) )
			pxlsPerMove = 6;
		else if ( keyboard -> press ( KEY_7 ) )
			pxlsPerMove = 7;
		else if ( keyboard -> press ( KEY_8 ) )
			pxlsPerMove = 8;
		else if ( keyboard -> press ( KEY_9 ) )
			pxlsPerMove = 9;
		else if ( keyboard -> press ( KEY_0 ) )
			pxlsPerMove = 10;
		else if ( keyboard -> press ( KEY_F1 ) )
			setScreenRes ( 640, 480 );
		else if ( keyboard -> press ( KEY_F2 ) )
			setScreenRes ( 800, 600 );
		else if ( keyboard -> press ( KEY_F3 ) )
			setScreenRes ( 1024, 768 );
		else if ( keyboard -> press ( KEY_F4 ) )
			setScreenRes ( 1152, 864 );
		else if ( keyboard -> press ( KEY_F5 ) )
			setScreenRes ( 1280, 1024 );
		else if ( keyboard -> press ( KEY_F6 ) )
			setScreenRes ( 1600, 1200 );
		else if ( keyboard -> press ( KEY_F7 ) )
			setScreenRes ( 2048, 1536 );
		else if ( keyboard -> press ( KEY_F8 ) ) {
			setScreenRes ( INT_MAX, INT_MAX );
			errMsg ( "That's just silly." );
		}

		gameMap -> draw ();

		pc -> draw ();
		pc -> run ();
		for ( Npcs::iterator it = npcs . begin (); it != npcs . end (); it++ ) {
			(*it) . second -> draw ();
			(*it) . second -> run ();
		}

		drawScreen ();
	}

	return ( EXIT_SUCCESS );
}
END_OF_MAIN ();