#ifndef HEAD_OBJ
#define HEAD_OBJ

#include "img.h"
#include "lib.h"
#include "gen.h"
#include <string>
#include <map>

class MapObj {

	protected:

	int x1, y1, x2, y2;
	Sprite * sprite;

	public:

	MapObj ( int imgId, int x, int y );
	MapObj ( Sprite * sprite, int x, int y );
	virtual ~MapObj () { ; }

	inline int retX1 () { return x1; }
	inline int retY1 () { return y1; }
	inline int retX2 () { return x2; }
	inline int retY2 () { return y2; }

	inline void setX ( int x ) { x1 = x; x2 = x1 + sprite -> retW () - 1; }
	inline void setY ( int y ) { y1 = y; y2 = y1 + sprite -> retH () - 1; }

	bool pxlColl ( Compass dir );
	bool boxColl ( Compass dir, int x1, int y1, int x2, int y2 );

	virtual void move ( Compass dir );

	void draw ();
	inline void draw ( int x, int y ) { sprite -> draw ( x, y ); }
};

extern Sprite * emptySprite;

class FaceObj : public MapObj {

	private:

	static const Compass DEFFACE = s;

	Compass face;
	typedef std::map<Compass, Sprite *> Faces;
	Faces faces;

	public:

	FaceObj ( std::string spriteFile, int x, int y, Compass face = DEFFACE );
	~FaceObj () { ; }

	inline Compass retFace () { return face; }
	void setFace ( Compass face );

	void loadFace ( Compass face, std::string spriteFile );

	void move ( Compass dir );
};

#endif