#include "pc.h"
#include "npc.h"
#include "actor.h"
#include "map.h"
#include "lib.h"
#include "gen.h"
#include <string>
using namespace std;



// Pc

Pc::Pc ( string pcDir, int x, int y )
: Actor ( pcDir, x, y ) {
	clearSkip ();
}

extern int moveCount;

void Pc::run () {
	if ( ! skip ) {
		if ( keyboard -> press ( KEY_SPACE ) )
			for ( Npcs::iterator it = npcs . begin (); it != npcs . end (); it++ )
				if ( mapObj -> boxColl ( mapObj -> retFace (), (*it).second -> retX1 (), (*it).second -> retY1 (), (*it).second -> retX2 (), (*it).second -> retY2 () ) )
					(*it).second -> setTalkedTo ( true );

		if ( keyboard -> press ( KEY_LEFT )
			|| keyboard -> press ( KEY_RIGHT )
			|| keyboard -> press ( KEY_DOWN )
			|| keyboard -> press ( KEY_UP ) )
			moveCount++;
		mapObj -> move ( keyboard -> dir () );
	} else
		clearSkip ();

	const int MIDPCX = ( retX1 () + retX2 () ) / 2;
	const int MIDPCY = ( retY1 () + retY2 () ) / 2;
	gameMap -> setFoc ( MIDPCX, MIDPCY );

	scripts . run ();
}

Pc * pc = NULL;

const char LIST_DATADELIMIT = ' ';
const string LIST_PC ( "^Pc" );

void loadPc ( string pcFile ) {
	if ( pc != NULL )
		fatErrMsg ( "Attempt to reload undestroyed pc from " + pcFile + "." );

	FileIn pcIn ( pcFile );

	while ( ! pcIn . eof () ) {
		string line = pcIn . getLine ();
		if ( line == LIST_PC ) {
			line = pcIn . getLine ();
				const int x = atoi ( line . substr ( 0, line . find ( LIST_DATADELIMIT ) ) . c_str () );
				line = line . substr ( line . find ( LIST_DATADELIMIT ) + 1, string::npos );
				const int y = atoi ( line . substr ( 0, line . find ( LIST_DATADELIMIT ) ) . c_str () );
				line = line . substr ( line . find ( LIST_DATADELIMIT ) + 1, string::npos );

				pc = new Pc ( line, x, y );
		}
	}
	if ( pc == NULL )
		fatErrMsg ( "No pc in actors file from " + pcFile + "." );
}

void destroyPc () {
	delete pc;
	pc = NULL;
}