#ifndef HEAD_RESULT
#define HEAD_RESULT

#include <string>
#include <vector>

class Actor;

// Results

class Result {

	protected:

	Actor * self;

	public:

	Result ( Actor * self ) { Result::self = self; }
	virtual ~Result () { ; }

	virtual void run () { ; }
};

class Set : public Result {

	private:

	int flagId;

	public:

	Set ( Actor * self, std::string flagName );
	~Set () { ; }

	void run ();
};

class Clear : public Result {

	private:

	int flagId;

	public:

	Clear ( Actor * self, std::string flagName );
	~Clear () { ; }

	void run ();
};

class Say : public Result {

	private:

	typedef std::vector <std::string> Dialogue;
	Dialogue dialogue;

	public:

	Say ( Actor * self, std::string say );
	~Say () { ; }

	void run ();
};

class SkipPc : public Result {

	public:

	SkipPc ( Actor * self );
	~SkipPc () { ; }

	void run ();
};

class StatRaise : public Result {

	private:

	std::string statName;
	int statAdd;

	public:

	StatRaise ( Actor * self, std::string args );
	~StatRaise () { ; }

	void run ();
};

class StatLower : public Result {

	private:

	std::string statName;
	int statSub;

	public:

	StatLower ( Actor * self, std::string args );
	~StatLower () { ; }

	void run ();
};

class ChangeMap : public Result {

	private:

	std::string newMapName;

	public:

	ChangeMap ( Actor * self, std::string args );
	~ChangeMap () { ; }

	void run ();
};

class Fight : public Result {

	public:

	Fight ( Actor * self );
	~Fight () { ; }

	void run ();
};

class ResultList {

	private:

	typedef std::vector<Result *> Results;
	Results results;

	std::string stripArg ( std::string & line );

	public:

	ResultList ( Actor * self, std::string line );
	~ResultList ();

	void run ();
};

#endif