#include "script.h"
#include "cond.h"
#include "result.h"
#include "gui.h"
#include <string>
#include <vector>
using namespace std;



// Script

Script::Script ( Actor * self, string line )
: condList ( self, line . substr ( 0, line . find ( DIV ) ) )
, resultList ( self, line . substr ( line . find ( DIV ) + 1, string::npos ) ) {
	condList . eval ();
}

void Script::run () {
	if ( condList . eval () ) {
		resultList . run ();
	}
}



// ScriptList

ScriptList::ScriptList ( Actor * self ) {
	ScriptList::self = self;
}

ScriptList::~ScriptList () {
	for ( Scripts::iterator it = scripts . begin (); it != scripts . end (); it ++ )
		delete (*it);
	scripts . clear ();
}

void ScriptList::addScript ( string line ) {
	Script * script = new Script ( self, line );
	scripts . push_back ( script );
}

void ScriptList::run () {
	for ( Scripts::iterator it = scripts . begin (); it != scripts.end (); it++ )
		(*it) -> run ();
}